// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "IShaderData.hpp"
#include "assert/assert.hpp"

using namespace Dawn;

void IShaderData::write(std::shared_ptr<ShaderProgram> shader) {
  assertNotNull(shader, "Shader cannot be null.");
  this->shader = shader;
  this->writeData();
  this->shader = nullptr;
}

std::shared_ptr<ShaderProgram> IShaderData::getShader() {
  return this->shader;
}