// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/IShaderData.hpp"

namespace Dawn {
  class ShaderData : public IShaderData {
    private:
      int32_t i = 0;
      
    protected:
      void beginStruct() override;
      void writeMat4(const glm::mat4 &mat) override;
      void writeVec3(const glm::vec3 &vec) override;
      void writeVec4(const glm::vec4 &vec) override;
      void writeColor(const struct Color &color) override;
      void writeBoolean(const bool &value) override;
      void writeTexture(std::shared_ptr<Texture> &texture) override;
      void endStruct() override;
  };
}