// Copyright (c) 2024 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "display/shader/IShaderProgram.hpp"
#include "dawnopengl.hpp"

namespace Dawn {
  class ShaderData;
  
  class ShaderProgram :
    public IShaderProgram,
    public std::enable_shared_from_this<ShaderProgram>
  {
    private:
      GLuint id = -1;

    public:
      void init(
        const std::vector<std::shared_ptr<ShaderStage>> &stages
      ) override;
      ~ShaderProgram();

      friend class ShaderData;
  };
}